//app接口
function runMobileApi(api, arr) {
    /*
    if (window.Activity && window.Activity[api]) {
        return window.Activity[api].apply(null, arr);
    }
    */
    switch(api){
        case "pingbackFromPage":
            window.Activity && window.Activity.pingbackFromPage && window.Activity.pingbackFromPage(arr[0],arr[1]);
            break;
        case "getArticleContent":
            return JSON.parse(window.Activity && window.Activity.getArticleContent && window.Activity.getArticleContent());
        case "onScrollNearEnd":
            window.Activity && window.Activity.onScrollNearEnd && window.Activity.onScrollNearEnd();
            break;
        case "onScrollDown":
            window.Activity && window.Activity.onScrollDown && window.Activity.onScrollDown(arr[0]);
            break;
        case "onScrollUp":
            window.Activity && window.Activity.onScrollUp && window.Activity.onScrollUp(arr[0]);
            break;
    }
}

//获取参数
function getQueryString(name) {
    var reg = new RegExp("(?:\\?|&)" + name + "=([^&]*)(&|$)", "i");
    var r = window.location.hash.match(reg);
    return r && unescape(r[1]);
}

//pingback
function pingback(type, obj) {
    var parameters = "";
    Object.keys(obj).forEach(function(key) {
        parameters += '&' + key + '=' + encodeURIComponent(obj[key]);
    })
    runMobileApi("pingbackFromPage", [type, parameters]);
}

function $(selector, context) {
    return (context || document).querySelector(selector);
}

//article模块
var article = {};
var articleEnterTime = new Date().getTime();
var articleNode = $("#article");
var viewHeight = Math.max(document.documentElement.clientHeight, window.innerHeight || 0);
var sign = 0;
var readed = false;

function pingbackArticleReaded() {
    if (!readed) {
        pingback("articleReaded", {});
        readed = true;
    }
}

article.loadData = function(data) {
    var data = runMobileApi("getArticleContent");
    $("#article_title").innerHTML = data.title;
    $("#article_source").innerHTML = data.source;
    $("#article_time").innerHTML = data.time;
    $("#article_content").innerHTML = data.content;
    //pingback "article"
    App.SendMessage("notifyDataLoaded");
    pingback("article", {
        status: data.content ? 1 : 0,
        time: new Date().getTime() - articleEnterTime
    });
}

article.show = function() {
    articleNode.scrollIntoView();
}

//夜间模式"night" 否则非夜间模式
article.toggleMode = function(mode) {
    mode = mode || getQueryString("mode");
    if (mode == "night") {
        document.body.classList.add("night-mode");
    } else {
        document.body.classList.remove("night-mode");
    }
}

//文章字体大小设置
article.setFontSize = function(n) {
    n = n || parseInt(getQueryString("fontSize"));
    $("#article_title").style.fontSize = n + "px";
    $("#article_source").style.fontSize = n / 2 + "px";
    $("#article_time").style.fontSize = n / 2 + "px";
    $("#article_content").style.fontSize = n / 1.2 + "px";
}

article.init = function() {

    //通过article屏幕滚动到指定位置来决定该文已读过并发送pingback "articleReaded"
    window.addEventListener('scroll', function(e) {
        if ((document.body.scrollHeight - viewHeight) * 4 / 5 <= document.body.scrollTop) {
            pingbackArticleReaded();
            runMobileApi("onScrollNearEnd");
        }

        var scrolltop = document.body.scrollTop;
        if (scrolltop > sign) { //向下
            sign = scrolltop;
            console.log(scrolltop + "down");
            runMobileApi("onScrollDown", [scrolltop]);
        }

        if (scrolltop < sign) { //向上
            sign = scrolltop;
            console.log(scrolltop + "up");
            runMobileApi("onScrollUp", [scrolltop]);
        }
    });

    //没有滚动条的情况下发送pingback "articleReaded"
    window.setTimeout(function() {
        if (viewHeight === document.body.scrollHeight) {
            pingbackArticleReaded();
        }
    }, 300);

    $("#article_go_back").addEventListener("click", function() {
        history.back();
    }, false)
}
